连接失败特使代理GRPC转码的HTTP [英] Connection failure envoyproxy grpc transcoded HTTP

查看:17
本文介绍了连接失败特使代理GRPC转码的HTTP的处理方法,对大家解决问题具有一定的参考价值,需要的朋友们下面随着小编来一起学习吧!

问题描述

我遵循这个tutorial,以便将grcp服务代码转换为HTTP(它在Linux上运行)。 特使API更新到了v3,所以我也遵循了example。 我已将ENAVAL_CONFIG更新为API v3,因此它符合此版本的新要求。

但是,当我部署坞站映像时,在尝试访问API终结点时出现错误。 例如,当我运行此命令curl http://localhost:51051/greeting(它是生成的API的公开终结点)时,我收到以下错误:upstream connect error or disconnect/reset before headers. reset reason: connection failure,状态代码为503

当我运行以下命令sudo docker ps时,我可以看到Port列中没有显示端口。 因此,我尝试使用docker run -p ...docker run --expose ...命令来映射/显示它们,但它们仍然没有出现。

我现在有点迷路了,因为我根本不知道码头,我甚至不知道我的问题是否与端口暴露有关。

但不管怎样,我必须说GRPC服务与Java服务器/客户端一起工作得很好。只是Web API(特使)不起作用。

如果您需要更多材料,我已经上传了整个项目here,因此您可以自己复制问题。

否则,这里是envoy-config.yml(公开的API端点是地址#2:0.0.0.0:51051):

admin:
  access_log_path: /tmp/admin_access.log
  address:
    socket_address: { address: 0.0.0.0, port_value: 9901 }         #1

static_resources:
  listeners:
  - name: main-listener
    address:
      socket_address: { address: 0.0.0.0, port_value: 51051 }      #2
    filter_chains:
    - filters:
      - name: envoy.filters.network.http_connection_manager
        typed_config:
          "@type": type.googleapis.com/envoy.extensions.filters.network.http_connection_manager.v3.HttpConnectionManager # Explicit v3
          stat_prefix: grpc_json
          codec_type: AUTO
          route_config:
            name: local_route
            virtual_hosts:
            - name: local_service
              domains: ["*"]
              routes:
              - match: { prefix: "/" , grpc: {}}  # 3a grpc:{} means that requests are only forwarded if they are found in the grpc service definition, returning 404 for others
                route: { cluster: grpc-backend-services, timeout: { seconds: 60 } }   #3b
          http_filters:
          - name: envoy.filters.http.grpc_json_transcoder
            typed_config:
              "@type": type.googleapis.com/envoy.extensions.filters.http.grpc_json_transcoder.v3.GrpcJsonTranscoder
              proto_descriptor: "/data/greeting_service_definition.pb"             #4
              services: ["helloworld.HelloService"]                        #5
              print_options:
                add_whitespace: true
                always_print_primitive_fields: true
                always_print_enums_as_ints: false
                preserve_proto_field_names: false                                     #6
          - name: envoy.filters.http.router

  clusters:
  - name: grpc-backend-services                  #7
    connect_timeout: 1.25s
    type: logical_dns
    lb_policy: round_robin
    dns_lookup_family: V4_ONLY
    typed_extension_protocol_options:
      envoy.extensions.upstreams.http.v3.HttpProtocolOptions:
        "@type": type.googleapis.com/envoy.extensions.upstreams.http.v3.HttpProtocolOptions
        explicit_http_config:
          http2_protocol_options: {}
    load_assignment:
      cluster_name: grpc-backend-services
      endpoints:
      - lb_endpoints:
        - endpoint:
            address:
              socket_address:
                address: 127.0.0.1                #8
                port_value: 53000

下面是运行protocdocker的脚本:

#!/usr/bin/env bash

if ! [ -x "$(command -v protoc)" ] ; then
    echo "you do not seem to have the protoc executable on your path"
    echo "we need protoc to generate a service defintion (*.pb file) that envoy can understand"
    echo "download the precompiled protoc executable and place it in somewhere in your systems PATH!"
    echo "goto: https://github.com/protocolbuffers/protobuf/releases/latest"
    echo "choose:"
    echo "       for linux:   protoc-3.6.1-linux-x86_64.zip"
    echo "       for windows: protoc-3.6.1-win32.zip"
    echo "       for mac:     protoc-3.6.1-osx-x86_64.zip"
    exit 1
fi

# generate the greeting_service_definition.pb file that we can pass to envoy so that knows the grpc service
# we want to expose
protoc -I. -Isrc/main/proto --include_imports 
                --include_source_info 
                --descriptor_set_out=greeting_service_definition.pb 
                src/main/proto/HelloService.proto

if ! [ $? -eq 0 ]; then
    echo "protobuf compilation failed"
    exit 1
fi

# now we can start envoy in a docker container and map the configuration and service definition inside
# we use --network="host" so that envoy can access the grpc service at localhost:<port>
# the envoy-config.yml has configured envoy to run at port 51051, so you can access the HTTP/JSON
# api at localhost:51051


if ! [ -x "$(command -v docker)" ] ; then
    echo "docker command is not available, please install docker"
    echo "Install docker: https://store.docker.com/search?offering=community&type=edition"
    exit 1
fi

# check if sudo is required to run docker
if [ "$(groups | grep -c docker)" -gt "0" ]; then
    echo "Envoy will run at port 51051 (see envoy-config.yml)"
    docker run -it --rm --name envoy --network="host" 
             -v "$(pwd)/greeting_service_definition.pb:/data/greeting_service_definition.pb:ro" 
             -v "$(pwd)/envoy-config.yml:/etc/envoy/envoy.yaml:ro" 
             envoyproxy/envoy:v1.18.2
else
    echo "you are not in the docker group, running with sudo"
    echo "Envoy will run at port 51051 (see envoy-config.yml)"
    sudo docker run -it --rm --name envoy --network="host"
             -v "$(pwd)/greeting_service_definition.pb:/data/greeting_service_definition.pb:ro" 
             -v "$(pwd)/envoy-config.yml:/etc/envoy/envoy.yaml:ro" 
             envoyproxy/envoy:v1.18.2
fi

推荐答案

503状态是因为转码操作失败--看起来特使无法连接到GRPC服务。

您已将特使配置为在host.docker.internal:53000连接到GRPC-如果您在Linux上使用docker,而不是在Mac/Windows上使用docker-desktop,这可能会出现问题。

而且Java服务器还监听端口8080,而不是53000,所以我认为您只需要更改这一点。

[编辑]

我确认了";host.docker.Internal";可以在Ubuntu 18.04上处理您的项目,调用docker的方式如下: docker run -it --rm --name envoy --add-host=host.docker.internal:host-bridge -p 51051:5105。在我测试的版本(F9e7c1)中,lb_endpoints所需的端口从53000更改为8080。

注意,这是使用默认的网桥网络模式,因此需要端口映射才能访问转码后的特使终结点。

您可以在&host";模式网络中运行特使容器-这稍微简单一些,因为您可以curl通过本地主机(无端口映射)到特使的转码终结点,并且特使也可以通过本地主机IP访问Java服务器。

有关处理此类容器间依赖关系的方法的详细摘要,请参阅this answer

这篇关于连接失败特使代理GRPC转码的HTTP的文章就介绍到这了,希望我们推荐的答案对大家有所帮助,也希望大家多多支持IT屋!

查看全文
登录 关闭
扫码关注1秒登录
发送“验证码”获取 | 15天全站免登陆